Bug 927746 - (CVE-2015-3148) VUL-0: CVE-2015-3148: curl: Negotiate not treated as connection-oriented
(CVE-2015-3148)
VUL-0: CVE-2015-3148: curl: Negotiate not treated as connection-oriented
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P3 - Medium : Normal
: ---
Assigned To: Security Team bot
Security Team bot
maint:released:sle10-sp3:61668 maint:...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2015-04-19 08:44 UTC by Marcus Meissner
Modified: 2017-06-16 12:06 UTC (History)
3 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments
temp-negotiate.patch (1.51 KB, patch)
2015-04-19 08:45 UTC, Marcus Meissner
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Marcus Meissner 2015-04-19 08:45:06 UTC
Created attachment 631530 [details]
temp-negotiate.patch

temp-negotiate.patch
Comment 2 Swamp Workflow Management 2015-04-19 22:00:14 UTC
bugbot adjusting priority
Comment 4 Swamp Workflow Management 2015-04-20 15:17:11 UTC
An update workflow for this issue was started.
This issue was rated as moderate.
Please submit fixed packages until 2015-05-04.
When done, reassign the bug to security-team@suse.de.
https://swamp.suse.de/webswamp/wf/61571
Comment 5 Bernhard Wiedemann 2015-04-22 09:00:27 UTC
This is an autogenerated message for OBS integration:
This bug (927746) was mentioned in
https://build.opensuse.org/request/show/298499 13.2+13.1 / curl
Comment 6 Andreas Stieger 2015-04-22 09:51:56 UTC
public via http://curl.haxx.se/docs/adv_20150422B.html

Negotiate not treated as connection-oriented
============================================

Project cURL Security Advisory, April 22nd 2015 -
[Permalink](http://curl.haxx.se/docs/adv_20150422B.html)

VULNERABILITY
-------------

libcurl keeps a pool of its last few connections around after use to
fascilitate easy, conventient and completely transparent connection re-use for
applications.

When doing HTTP requests Negotiate authenticated, the entire connnection may
become authenticated and not just the specific HTTP request which is otherwise
how HTTP works, as Negotiate can basically use NTLM under the hood. curl was
not adhering to this fact but would assume that such requests would also be
authenticated per request.

The net effect is that libcurl may end up re-using an authenticated Negotiate
connection and sending subsequent requests on it using new credentials, while
the connection remains authenticated with a previous initial credentials
setup.

We are not aware of any exploits of this flaw.

INFO
----

This flaw can also affect the curl command line tool if a similar operation
series is made with that.

The Common Vulnerabilities and Exposures (CVE) project has assigned the name
CVE-2015-3148 to this issue.

AFFECTED VERSIONS
-----------------

- Affected versions: from libcurl 7.10.6 to and including 7.41.0
- Not affected versions: libcurl >= 7.42.0

libcurl is used by many applications, but not always advertised as such!

THE WORK-AROUND
---------------

libcurl 7.42.0 closes Negotiate connections after they're done, effectively
preventing wrongful re-use. We decided to do this blunt short-term fix to
avoid this current problem and then continue to work on a better fix.

A patch for this problem is available at:

    http://curl.haxx.se/CVE-2015-3148.patch

RECOMMENDATIONS
---------------

We suggest you take one of the following actions immediately, in order of
preference:

A - Upgrade to curl and libcurl 7.42.0

B - Apply the patch and rebuild libcurl

C - Avoid using Negotiate with libcurl

TIME LINE
---------

It was first reported to the curl project on March 31 2015. We contacted
distros@openwall on April 18.

libcurl 7.42.0 was released on April 22nd 2015, coordinated with the
publication of this advisory.

CREDITS
-------

Reported by Isaac Boukris

Thanks a lot!
Comment 10 Swamp Workflow Management 2015-04-29 09:05:47 UTC
openSUSE-SU-2015:0799-1: An update that fixes four vulnerabilities is now available.

Category: security (moderate)
Bug References: 927556,927607,927608,927746
CVE References: CVE-2015-3143,CVE-2015-3144,CVE-2015-3145,CVE-2015-3148
Sources used:
openSUSE 13.2 (src):    curl-7.42.0-7.1
openSUSE 13.1 (src):    curl-7.42.0-2.38.1
Comment 17 Hanns-Joachim Uhl 2015-05-26 14:16:40 UTC
Hello SUSE,
... is there an outlook when this update will be available
on the maintweb for SLES 11 SP3 ...?
I got this question from the field ... please advise.
Thanks for your support.
Comment 18 Andreas Stieger 2015-05-26 15:12:01 UTC
(In reply to Hanns-Joachim Uhl from comment #17)
> Hello SUSE,
> ... is there an outlook when this update will be available
> on the maintweb for SLES 11 SP3 ...?
> I got this question from the field ... please advise.
> Thanks for your support.

QA currently estimated to complete on 28th.
Comment 19 Swamp Workflow Management 2015-05-28 14:05:30 UTC
SUSE-SU-2015:0962-1: An update that solves three vulnerabilities and has one errata is now available.

Category: security (moderate)
Bug References: 927174,927556,927746,928533
CVE References: CVE-2015-3143,CVE-2015-3148,CVE-2015-3153
Sources used:
SUSE Linux Enterprise Software Development Kit 11 SP3 (src):    curl-7.19.7-1.42.1
SUSE Linux Enterprise Server 11 SP3 for VMware (src):    curl-7.19.7-1.42.1
SUSE Linux Enterprise Server 11 SP3 (src):    curl-7.19.7-1.42.1
SUSE Linux Enterprise Desktop 11 SP3 (src):    curl-7.19.7-1.42.1
Comment 20 Swamp Workflow Management 2015-06-03 07:05:42 UTC
SUSE-SU-2015:0990-1: An update that fixes 5 vulnerabilities is now available.

Category: security (moderate)
Bug References: 927556,927607,927608,927746,928533
CVE References: CVE-2015-3143,CVE-2015-3144,CVE-2015-3145,CVE-2015-3148,CVE-2015-3153
Sources used:
SUSE Linux Enterprise Software Development Kit 12 (src):    curl-7.37.0-15.1
SUSE Linux Enterprise Server 12 (src):    curl-7.37.0-15.1
SUSE Linux Enterprise Desktop 12 (src):    curl-7.37.0-15.1
Comment 21 Andreas Stieger 2015-06-12 13:30:53 UTC
This one also looks like it is fixed everywhere.